package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.VReateDocumentos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * VReateDocumentosDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class VReateDocumentosDaoImpl implements VReateDocumentosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDOCUMENTO", "IDDOCUMENTOAB61",
			"IDESTABLECIMIENTO", "IDENTIFICADORESTABLECIMIENTO", "NOMBREDOCUMENTO", "IDTIPOPLANTILLA",
			"DESCPLANTILLACASTELLANO", "DESCPLANTILLAEUSKERA", "FECHAAPORTADOPID", "OID", "REPOSITORIO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<VReateDocumentos> rwMap = new RowMapper<VReateDocumentos>() {
		public VReateDocumentos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			VReateDocumentos vReateDocumentos = new VReateDocumentos();
			vReateDocumentos.setNombreDocumento(resultSet.getString("NOMBREDOCUMENTO"));
			vReateDocumentos.setIdTipoPlantilla(resultSet.getInt("IDTIPOPLANTILLA"));
			vReateDocumentos.setDescPlantillaCastellano(resultSet.getString("DESCPLANTILLACASTELLANO"));
			vReateDocumentos.setDescPlantillaEuskera(resultSet.getString("DESCPLANTILLAEUSKERA"));
			vReateDocumentos.setFechaAportadoPid(resultSet.getDate("FECHAAPORTADOPID"));
			vReateDocumentos.setOid(resultSet.getString("OID"));
			vReateDocumentos.setRepositorio(resultSet.getString("REPOSITORIO"));

			return vReateDocumentos;
		}
	};

	private RowMapper<VReateDocumentos> rwMapPK = new RowMapper<VReateDocumentos>() {
		public VReateDocumentos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new VReateDocumentos(resultSet.getInt("ID_DOCUMENTO"), resultSet.getInt("ID_DOCUMENTO_AB61"),
					resultSet.getInt("ID_ESTABLECIMIENTO"), resultSet.getString("IDENTIFICADOR_ESTABLECIMIENTO"),
					resultSet.getString("NOMBRE_DOCUMENTO"), resultSet.getInt("ID_TIPO_PLANTILLA"),
					resultSet.getString("DESC_PLANTILLA_CASTELLANO"), resultSet.getString("DESC_PLANTILLA_EUSKERA"),
					resultSet.getDate("FECHA_APORTADO_PID"), resultSet.getString("OID"),
					resultSet.getString("REPOSITORIO"));
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Override
	public List<VReateDocumentos> findDocumentacionActividad(VReateDocumentos filterVReateDocumentos,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO, t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA, t1.DESC_PLANTILLA_CASTELLANO DESCPLANTILLACASTELLANO, t1.DESC_PLANTILLA_EUSKERA DESCPLANTILLAEUSKERA, t1.FECHA_APORTADO_PID FECHAAPORTADOPID, t1.OID OID, t1.REPOSITORIO REPOSITORIO FROM AB61.V_REATE_DOCUMENTOS t1 WHERE t1.IDENTIFICADOR_ESTABLECIMIENTO = ?");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					VReateDocumentosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<VReateDocumentos>) this.jdbcTemplate.query(query.toString(), this.rwMap,
				filterVReateDocumentos.getIdentificadorEstablecimiento());
	}

	@Override
	public Long findDocumentacionActividadCount(VReateDocumentos vReateDocumentos) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM AB61.V_REATE_DOCUMENTOS t1 WHERE t1.IDENTIFICADOR_ESTABLECIMIENTO = ?");
		List<Object> params = new ArrayList<Object>();
		params.add(vReateDocumentos.getIdentificadorEstablecimiento());
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of VReateDocumentos selected for rup_table
	 *
	 * @param vreatedocumentos
	 *            VReateDocumentos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VReateDocumentos>>
	 */
	@Override
	public List<TableRowDto<VReateDocumentos>> reorderSelection(VReateDocumentos vreatedocumentos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DOCUMENTO IDDOCUMENTO,t1.ID_DOCUMENTO_AB61 IDDOCUMENTOAB61,t1.ID_ESTABLECIMIENTO IDESTABLECIMIENTO,t1.IDENTIFICADOR_ESTABLECIMIENTO IDENTIFICADORESTABLECIMIENTO,t1.NOMBRE_DOCUMENTO NOMBREDOCUMENTO,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.DESC_PLANTILLA_CASTELLANO DESCPLANTILLACASTELLANO,t1.DESC_PLANTILLA_EUSKERA DESCPLANTILLAEUSKERA,t1.FECHA_APORTADO_PID FECHAAPORTADOPID,t1.OID OID,t1.REPOSITORIO REPOSITORIO ");
		// FROM
		query.append("FROM V_REATE_DOCUMENTOS t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(vreatedocumentos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				VReateDocumentos.class, filterParamList,
				"ID_DOCUMENTO,ID_DOCUMENTO_AB61,ID_ESTABLECIMIENTO,IDENTIFICADOR_ESTABLECIMIENTO,NOMBRE_DOCUMENTO,ID_TIPO_PLANTILLA,DESC_PLANTILLA_CASTELLANO,DESC_PLANTILLA_EUSKERA,FECHA_APORTADO_PID,OID,REPOSITORIO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<VReateDocumentos>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the VReateDocumentos entity
	 *
	 * @param vreatedocumentos
	 *            VReateDocumentos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(VReateDocumentos vreatedocumentos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(VReateDocumentosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (vreatedocumentos != null && vreatedocumentos.getIdDocumento() != null) {
			where.append(" AND t1.ID_DOCUMENTO = ?");
			params.add(vreatedocumentos.getIdDocumento());
		}
		if (vreatedocumentos != null && vreatedocumentos.getIdDocumentoAb61() != null) {
			where.append(" AND t1.ID_DOCUMENTO_AB61 = ?");
			params.add(vreatedocumentos.getIdDocumentoAb61());
		}
		if (vreatedocumentos != null && vreatedocumentos.getIdEstablecimiento() != null) {
			where.append(" AND t1.ID_ESTABLECIMIENTO = ?");
			params.add(vreatedocumentos.getIdEstablecimiento());
		}
		if (vreatedocumentos != null && vreatedocumentos.getIdentificadorEstablecimiento() != null) {
			where.append(" AND t1.IDENTIFICADOR_ESTABLECIMIENTO = ?");
			params.add(vreatedocumentos.getIdentificadorEstablecimiento());
		}
		if (vreatedocumentos != null && vreatedocumentos.getNombreDocumento() != null) {
			where.append(" AND t1.NOMBRE_DOCUMENTO = ?");
			params.add(vreatedocumentos.getNombreDocumento());
		}
		if (vreatedocumentos != null && vreatedocumentos.getIdTipoPlantilla() != null) {
			where.append(" AND t1.ID_TIPO_PLANTILLA = ?");
			params.add(vreatedocumentos.getIdTipoPlantilla());
		}
		if (vreatedocumentos != null && vreatedocumentos.getDescPlantillaCastellano() != null) {
			where.append(" AND t1.DESC_PLANTILLA_CASTELLANO = ?");
			params.add(vreatedocumentos.getDescPlantillaCastellano());
		}
		if (vreatedocumentos != null && vreatedocumentos.getDescPlantillaEuskera() != null) {
			where.append(" AND t1.DESC_PLANTILLA_EUSKERA = ?");
			params.add(vreatedocumentos.getDescPlantillaEuskera());
		}
		if (vreatedocumentos != null && vreatedocumentos.getFechaAportadoPid() != null) {
			where.append(" AND t1.FECHA_APORTADO_PID = ?");
			params.add(vreatedocumentos.getFechaAportadoPid());
		}
		if (vreatedocumentos != null && vreatedocumentos.getOid() != null) {
			where.append(" AND t1.OID = ?");
			params.add(vreatedocumentos.getOid());
		}
		if (vreatedocumentos != null && vreatedocumentos.getRepositorio() != null) {
			where.append(" AND t1.REPOSITORIO = ?");
			params.add(vreatedocumentos.getRepositorio());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
